# importiamo la funzione "valore assoluto" dalla libreria math di python
from math import *

# importiamo due moduli precedentemente scritti da noi (devono risiedere nella medesima 
# cartella in cui si trova questo file)
#
from mypower import mypow
from fattoriale import	fact

# calcola e restituisce il seno di x in un intorno dell'origine, utilizzando lo sviluppo in serie di Taylor
#
# sin(x) = x - x^3/3! + x^5/5! - x^7/7! +...
#
# dove la scrittura x^3 indica x elevato al cubo e cosi` via..
#
# Fermandosi al grado settimo, la serie di Taylor approssima bene il seno per un periodo
# compreso tra -PI e PI 
#
def sen(x, precisione):
	# memorizza il valore del seno via via che viene computato
	senx = 0
	# grado del polinomio (e fattoriale al denominatore)
	n = 1

	segno = 1
	
	itcnt = 0
	
	termine_corrente = 1

	while(abs(termine_corrente) > precisione):
		 itcnt = itcnt + 1
		 termine_corrente = segno * mypow(x, n) / fact(n)
	
		 senx = senx + termine_corrente
	 
		 # 1, 3, 5, 7...
		 n = n + 2

		 # i segni si alternano...
		 segno = -segno

		 print("iteraz ", itcnt)

	print("La funzione sen ha richiesto un polinomio di grado", n-2, "per la precisione richiesta")
	
	return senx


